package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[DF] 数据对象
 */
@TableName(value = "T_DF",resultMap = "DFResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class DF extends EntityBase implements Serializable{

    private Integer bqs;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @TableId(value= "dfid",type=IdType.UUID)//指定主键生成策略
    private String dfid;
    private String dfname;
    private Timestamp jfrq;
    @Dict(dictName = "ionicdemo_CodeList81CodeList")
    private String nd;
    private String sfdj;
    private Integer sqds;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private Double ydfy;
    private Integer ydl;
    /**
     *  设置属性值[本期数]
     *  @param bqs
     */
    public void setBqs(Integer bqs){
        this.bqs = bqs;
        this.set("bqsdirtyflag",true);
    }
    /**
     *  获取属性值[本期数]
     */
    public Integer getBqs(){
        return this.bqs;
    }
    /**
     *  重置属性值[本期数]
     */
    public void resetBqs(){
        this.set("bqsdirtyflag",false);
        this.bqs = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[电费标识]
     *  @param dfid
     */
    public void setDfid(String dfid){
        if(StringUtils.isEmpty(dfid))
            dfid=null;
        this.dfid = dfid;
        this.set("dfiddirtyflag",true);
    }
    /**
     *  获取属性值[电费标识]
     */
    public String getDfid(){
        return this.dfid;
    }
    /**
     *  重置属性值[电费标识]
     */
    public void resetDfid(){
        this.set("dfiddirtyflag",false);
        this.dfid = null;
    }
    /**
     *  设置属性值[电费名称]
     *  @param dfname
     */
    public void setDfname(String dfname){
        if(StringUtils.isEmpty(dfname))
            dfname=null;
        this.dfname = dfname;
        this.set("dfnamedirtyflag",true);
    }
    /**
     *  获取属性值[电费名称]
     */
    public String getDfname(){
        return this.dfname;
    }
    /**
     *  重置属性值[电费名称]
     */
    public void resetDfname(){
        this.set("dfnamedirtyflag",false);
        this.dfname = null;
    }
    /**
     *  设置属性值[计费日期]
     *  @param jfrq
     */
    public void setJfrq(Timestamp jfrq){
        this.jfrq = jfrq;
        this.set("jfrqdirtyflag",true);
    }
    /**
     *  获取属性值[计费日期]
     */
    public Timestamp getJfrq(){
        return this.jfrq;
    }
    /**
     *  重置属性值[计费日期]
     */
    public void resetJfrq(){
        this.set("jfrqdirtyflag",false);
        this.jfrq = null;
    }
    /**
     *  设置属性值[年度]
     *  @param nd
     */
    public void setNd(String nd){
        if(StringUtils.isEmpty(nd))
            nd=null;
        this.nd = nd;
        this.set("nddirtyflag",true);
    }
    /**
     *  获取属性值[年度]
     */
    public String getNd(){
        return this.nd;
    }
    /**
     *  重置属性值[年度]
     */
    public void resetNd(){
        this.set("nddirtyflag",false);
        this.nd = null;
    }
    /**
     *  设置属性值[收费单据]
     *  @param sfdj
     */
    public void setSfdj(String sfdj){
        if(StringUtils.isEmpty(sfdj))
            sfdj=null;
        this.sfdj = sfdj;
        this.set("sfdjdirtyflag",true);
    }
    /**
     *  获取属性值[收费单据]
     */
    public String getSfdj(){
        return this.sfdj;
    }
    /**
     *  重置属性值[收费单据]
     */
    public void resetSfdj(){
        this.set("sfdjdirtyflag",false);
        this.sfdj = null;
    }
    /**
     *  设置属性值[上期底数]
     *  @param sqds
     */
    public void setSqds(Integer sqds){
        this.sqds = sqds;
        this.set("sqdsdirtyflag",true);
    }
    /**
     *  获取属性值[上期底数]
     */
    public Integer getSqds(){
        return this.sqds;
    }
    /**
     *  重置属性值[上期底数]
     */
    public void resetSqds(){
        this.set("sqdsdirtyflag",false);
        this.sqds = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用电费用]
     *  @param ydfy
     */
    public void setYdfy(Double ydfy){
        this.ydfy = ydfy;
        this.set("ydfydirtyflag",true);
    }
    /**
     *  获取属性值[用电费用]
     */
    public Double getYdfy(){
        return this.ydfy;
    }
    /**
     *  重置属性值[用电费用]
     */
    public void resetYdfy(){
        this.set("ydfydirtyflag",false);
        this.ydfy = null;
    }
    /**
     *  设置属性值[用电量]
     *  @param ydl
     */
    public void setYdl(Integer ydl){
        this.ydl = ydl;
        this.set("ydldirtyflag",true);
    }
    /**
     *  获取属性值[用电量]
     */
    public Integer getYdl(){
        return this.ydl;
    }
    /**
     *  重置属性值[用电量]
     */
    public void resetYdl(){
        this.set("ydldirtyflag",false);
        this.ydl = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetBqs();
        resetCreatedate();
        resetCreateman();
        resetDfid();
        resetDfname();
        resetJfrq();
        resetNd();
        resetSfdj();
        resetSqds();
        resetUpdatedate();
        resetUpdateman();
        resetYdfy();
        resetYdl();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public DF copyTo(DF targetEntity)
	{
		BeanCopier copier=BeanCopier.create(DF.class, DF.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetDfid();
		return targetEntity;
	}
}